--STDIO.h    Probably Taken Origionaly from Xinhuan's BankItems :D
local tablePool = {};
setmetatable(tablePool, {__mode = "kv"});	-- Weak table
-- Get a new table
local function newtable()
	local t = next(tablePool) or {};
	tablePool[t] = nil;
	return t;
end
-- Delete table and add to table pool
local function deltable(t)
	if (type(t) == "table") then
		for k, v in pairs(t) do
			if (type(v) == "table") then
				deltable(v);	-- child tables get put into the pool
			end
			t[k] = nil;
		end
		setmetatable(t, nil);
		t[true] = true;
		t[true] = nil;
		tablePool[t] = true;
	end
	return nil;
end
-- end STDIO.h


if not GuildEventRecord_Nice then GuildEventRecord_Nice = {} end
if not GuildEventRecord then GuildEventRecord = {} end
-------
LogRecorder = {}

function LogRecorder:ClearLogs()
	GuildEventRecord_Nice = deltable(GuildEventRecord_Nice)
	GuildEventRecord = deltable(GuildEventRecord)
	GuildEventRecord_Nice = newtable()
	GuildEventRecord = newtable()
end
--------  These 2 functions knowingly stolen from Ckknight's ClockFu -- thanks :D
function LogRecorder:GetLocalOffset()
	if self.localOffset ~= nil then
		return self.localOffset
	end
	local localHour = tonumber(date("%H"))
	local localMinute = tonumber(date("%M"))
	local utcHour = tonumber(date("!%H"))
	local utcMinute = tonumber(date("!%M"))
	local loc = localHour + localMinute / 60
	local utc = utcHour + utcMinute / 60
	self.localOffset = floor((loc - utc) * 2 + 0.5) / 2
	if self.localOffset >= 12 then
		self.localOffset = self.localOffset - 24
	end
	return self.localOffset
end
function LogRecorder:GetServerOffset()
	if self.serverOffset ~= nil then
		return self.serverOffset
	end
	local serverHour, serverMinute = GetGameTime()
	local utcHour = tonumber(date("!%H"))
	local utcMinute = tonumber(date("!%M"))
	local ser = serverHour + serverMinute / 60
	local utc = utcHour + utcMinute / 60
	self.serverOffset = floor((ser - utc) * 2 + 0.5) / 2
	if self.serverOffset >= 12 then
		self.serverOffset = self.serverOffset - 24
	elseif self.serverOffset < -12 then
		self.serverOffset = self.serverOffset + 24
	end
	return self.serverOffset
end
-----------

local sec_hour = 3600
local sec_day = 86400
local sec_year = 31536000
-- 30_day_Month = 2592000
-- 31_day_month = 2678400
-- 29_day_month = 2505600

local month_sec = {
   [1] = 2678400,	--31
   [2] = 2505600,	--29
   [3] = 2678400,	--31
   [4] = 2592000,	--30
   [5] = 2678400,	--31
   [6] = 2592000,	--30
   [7] = 2678400,	--31
   [8] = 2678400,	--31
   [9] = 2592000,	--30
   [10] = 2678400,	--31
   [11] = 2592000,	--30
   [12] = 2678400,	--31
}

local function GetSecFromMonth(offset, current)
   if offset == 0 or nil then return 0 end
   local mo_sec = 0
   for i = current, offset, -1 do
      mo_sec = mo_sec + month_sec[i]
   end
   return mo_sec
end
local TimeOffset = false
local function GetOffSetTime()
	if not TimeOffset then
		TimeOffset = ((LogRecorder:GetLocalOffset())-(LogRecorder:GetServerOffset()))*sec_hour
	end
	return TimeOffSet
end

local function GetRealEventTime(dYear, dMonth, dDay, dHour)
   dYear = dYear or 0
   dMonth = dMonth or 0
   dDay = dDay or 0
   dHour = dHour or 0
   local dif

   dif = dHour*sec_hour + (dDay*sec_day) + GetSecFromMonth(dMonth, date("%m")) + (dYear*sec_year)
   return string.lower(date("%m/%d/%Y %I%p", (time()-GetOffSetTime() - dif)))
end



--player1.." "..eType.." "..player2..", To: "..rank.." On: "..GetRealEventTime(year, month, day, hour)
function LogRecorder:GuildLogExport()
	ChatFrame1:AddMessage("Starting Export of Guild Log")
	local type, player1, player2, rank, year, month, day, hour, msg
	for i=GetNumGuildEvents(),1, -1 do
		type, player1, player2, rank, year, month, day, hour = GetGuildEventInfo(i);
		if ( not player1 ) then
			player1 = "Unknown";
		end
		
		if ( not player2 ) then
			player2 = "Unknown";
		end
		
		if ( type == "join" ) then
			msg = format(GUILDEVENT_TYPE_JOIN, player1);
		-- elseif ( type == "invite" ) then
			-- msg = format(GUILDEVENT_TYPE_INVITE, player1, player2);
		-- elseif ( type == "promote" ) then
			-- msg = format(GUILDEVENT_TYPE_PROMOTE, player1, player2, rank);
		-- elseif ( type == "demote" ) then
			-- msg = format(GUILDEVENT_TYPE_DEMOTE, player1, player2, rank);
		elseif ( type == "remove" ) then
			msg = format(GUILDEVENT_TYPE_REMOVE, player1, player2);
		elseif ( type == "quit" ) then
			msg = format(GUILDEVENT_TYPE_QUIT, player1);
		else
			msg = nil
		end
		
		if ( msg ) and ( not GuildEventRecord[msg.." On: "..GetRealEventTime(year, month, day, hour)]) then
			GuildEventRecord[msg.." On: "..GetRealEventTime(year, month, day, hour)] = true
			tinsert(GuildEventRecord_Nice, msg.." On: "..GetRealEventTime(year, month, day, hour)  )
			-- Dirty Version that i don't give a fk about
			-- tinsert(GuildEventRecord_Dirty, { ["Officer"] = player1, ["Member"] = player2, ["Rank"] = rank, ["Action"] = type, ["Time"] = GetRealEventTime(year, month, day, hour)}
		end
	end
	ChatFrame1:AddMessage("Export of Guild Log Finished")
end
